#!/usr/bin/perl

#generate 'Int' file for glove;
#file reads in pklist generated from nmrDraw
#also reads in ?.dat ??.dat files which are the spectra in txt format from pipe2txt.tcl script.
# note header vals are generated within (below) and should be edited accordingly for each dosy setup
#
# USAGE mkInt.pl test.tab >Int

use Math::Trig;

$pi = 3.141592653;
$scale=1;

# get peak lists from 1D .xpk
open LIST, $ARGV[0];
$i = 0;
while (defined($line = <LIST>)) {;
	@fields = split(/\s+/, $line);
                         if($fields[1]>0){
			$index[$i] = $fields[1];
 			$pk[$i]=$fields[4];
                        $pk[$i] = sprintf("%.3f", $pk[$i]);
#			print "i is $i, peak $index[$i], ppm is $pk[$i] \n";
			$i += 1;
			$numpks=@index;
}
};
#			print "number of pks $numpks\n";
close LIST;

#get list of files in directory named .dat
opendir(DIR,".") ;
@files = grep(/\.dat$/,readdir(DIR));
closedir(DIR);

# print all the filenames in our array
foreach $file (@files) {
split(/\s+/,);
($filnum,$junk) = split(/\./,$file);
#print "filnumber is $filnum\n";

	open(INA, $file) || die "Can't open file $filea.\n";

	while($line = <INA>){
	@val = split(/\s+/,$line);
        chop($line);
   	$ppm{$filnum}{$count} = $val[1];
   	$int{$filnum}{$count} = $val[2]/$scale;
   	$count=$count+1;
    #   print " $count  $val[1] $val[2]\n";
	}
	close(INA);
        $count=0;
}

######## Create tau values for header 
$probe = 53.5; #this is 5.35G/cm/A for a z-gradient probe; 100%=10A
$probe = 53500; #typically analyzed in m2/s at 10A
#$ampsmax=10.0;
#I=Ioe(-D*gamma^2*g^2*gpul^2*delta)
$gamma= 4258; #Hz/G
$gpul=0.001;
$delta=0.100-($gpul/3); #diffusion time
$low=0.05;
$high=0.95;
$start = 1;
$finish = 16;

$inc=($high-$low)/($finish-$start);
$g=$probe*$low;
$Q=($g*$gamma*$gpul)**2*$delta;
$gpct=$low;
for($i = $start; $i < $finish+1; $i = $i + 1){
   #printf"%-2.0f %2.2f %3.2f\n",$i, $inc, $gpct;
   printf"%3.4f ",$Q/1e9;
   $gpct=$gpct+$inc;
   $g=$gpct*$probe;
   $Q=($g*$gamma*$gpul)**2*$delta;
   }
      printf"\n";

##################

#SORT all files according to number and print
for ($i=0; $i < $numpks; $i++){
       printf "%4.0f %4.0f HN\t",$i, $i;
foreach $filnum ( sort numerically keys %ppm ) {
foreach $count ( sort numerically keys %{$ppm{$filnum} } ) {
#if ($ppm{$filnum}{$count} < $high[$i] && $ppm{$filnum}{$count}> $low[$i] && $filnum > 0){
if ($ppm{$filnum}{$count} == $pk[$i] && $filnum > 0 && $ppm{$filnum}{$count} != $ppm{$filnum}{$count+1}){
#       printf "%2.3f\t", $ppm{$filnum}{$count};
       printf "%2.4f\t", $int{$filnum}{$count}/$int{1}{$count};
#       printf "%7.0f\t ", $filnum;
}
}
}
       printf "\n";
}
exit;

sub numerically { $a <=> $b; }
