#!/usr/bin/perl

#generate 'Int' file for glove;
#file reads in pklist for integral ranges (8-11 or 11-8, order doesn't matter) 
#also reads in ?.dat ??.dat files which are the spectra in txt format from pipe2txt.tcl script.
# note header vals are generated within (below) and should be edited accordingly for each dosy setup
#
# USAGE makeIntegral man.xpk >Int

use Math::Trig;

$pi = 3.141592653;
$scale=1;

# get peak lists from 1D .xpk
open LIST, $ARGV[0];
$i = 0;
while (defined($line = <LIST>)) {;
	@fields = split(/\s+/, $line);
			$peak[$i] = $fields[0];
			($a[$i], $b[$i]) = split(/-/, $fields[1]);
    			if ($a==$b){                     
			$high[$i]=$a[$i];
			$low[$i]=$b[$i];}
    			if ($a[$i]>$b[$i]){                     
			$high[$i]=$a[$i];
			$low[$i]=$b[$i];}
			else{
			$high[$i]=$b[$i];
			$low[$i]=$a[$i];
			}
                        $high[$i] = sprintf("%.3f", $high[$i]);
                        $low[$i] = sprintf("%.3f", $low[$i]);
#			print "i is $i, peak $peak[$i], ppm is $high[$i] $low[$i]\n";
			$i += 1;
			$numpks=$i;
};
#			print "number of pks $numpks\n";
close LIST;

#get list of files in directory named .dat
opendir(DIR,".") ;
@files = grep(/\.dat$/,readdir(DIR));
closedir(DIR);

# print all the filenames in our array
foreach $file (@files) {
split(/\s+/,);
($filnum,$junk) = split(/\./,$file);
#print "filnumber is $filnum\n";

	open(INA, $file) || die "Can't open file $filea.\n";

	while($line = <INA>){
	@val = split(/\s+/,$line);
        chop($line);
   	$ppm{$filnum}{$count} = $val[1];
   	$int{$filnum}{$count} = $val[2]/$scale;
   	$count=$count+1;
    #   print " $count  $val[1] $val[2]\n";
	}
	close(INA);
        $count=0;
}


######## Create tau values for header 
$probe = 53.5; #this is 5.35G/cm/A for a z-gradient probe; 100%=10A
$probe = 53500; #typically analyzed in m2/s at 10A
#$ampsmax=10.0;
#I=Ioe(-D*gamma^2*g^2*gpul^2*delta)
$gamma= 4258; #Hz/G
$gpul=0.001;
$delta=0.100-($gpul/3); #diffusion time
$low=0.05;
$high=0.95;
$start = 1;
$finish = 16;

$inc=($high-$low)/($finish-$start);
$g=$probe*$low;
$Q=($g*$gamma*$gpul)**2*$delta;
$gpct=$low;
for($i = $start; $i < $finish+1; $i = $i + 1){
   #printf"%-2.0f %2.2f %3.2f\n",$i, $inc, $gpct;
   printf"%3.4f ",$Q/1e9;
   $gpct=$gpct+$inc;
   $g=$gpct*$probe;
   $Q=($g*$gamma*$gpul)**2*$delta;
   }
      printf"\n";

##################

#SORT all files according to number and print
for ($i=0; $i < $numpks; $i++){
foreach $filnum ( sort numerically keys %ppm ) {
foreach $count ( sort numerically keys %{$ppm{$filnum} } ) {
    if ($ppm{$filnum}{$count} < $high[$i] && $ppm{$filnum}{$count}> $low[$i] && $filnum > 0){
#       printf "%7.3f ", $ppm{$filnum}{$count};
#       printf "%7.0f ", $int{$filnum}{$count};
#       printf "%7.0f ", $i;
#       printf "%7.0f ", $filnum;
       $add[$i][$filnum] =$add[$i][$filnum] +  $int{$filnum}{$count};
#       printf "%7.0f\n ", $add[$i][$filnum];
}
}
}
}
######################################
# PRINT OUT INTEGRATED VALUES
#print scalar(@files);
$numfiles=@files;
# print out integrated peaks
for ($i=0; $i < $numpks; $i++){
       printf "%4.0f %4.0f HN ",$i, $i;
for ($x=1; $x<= $numfiles; $x++){
       printf "%2.5f ", $add[$i][$x]/$add[$i][1];
       #printf "%2.5f ", $add[$i][$x];
}
       print "\n";
}
exit;

sub numerically { $a <=> $b; }
